import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.NumberFormat;


public class aufgabe_3_1 extends Applet
{
	String code_ = "53|305))6*;4826)4.)4);806*;48|8#60))85;1(;:*8|83(88)5*|;46(;88*96*?;8)*(;485);5*|2:*(;4956*2(5*-4)8#8*;4069285);)6|8)4;1(9;48081;8:81;48|85;4)485|528806*81(9;48;(88;4(?34;48)4;161;:188;?;";
	String code = "53|305))6*;4826)4.)4);806*;48|8#60))85;1(;:*8|83(88)5*|;46(;88*96*?;8)*(;485);5*|2:*(;4956*2(5*-4)8#8*;4069285);)6|8)4;1(9;48081;8:81;48|85;4)485|528806*81(9;48;(88;4(?34;48)4;161;:188;?;";

	char	MAXHELPS = 19;
	String	helps[] = new String[MAXHELPS];
	int		index_help = 0;

	TextArea	input = new TextArea("" , 40 , 5 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextArea	msg = new TextArea("" , 40 , 5 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextArea	text = new TextArea("" , 40 , 5 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	
	TextField	char1 = new TextField("" , 1);
	TextField	char2 = new TextField("" , 1);
	
	char	LETTERS_ENG = 26;	//number of english letters
	char	BIGRAMMS_ENG = 10;	//number of english bigramms in database
	char	TRIGRAMMS_ENG = 7;	//number of english trigramms in database

	char	LETTERS_MAX = 255;		//maximum of different signs in the code
	int		BIGRAMMS_MAX = 1000;		//maximum of different bigramms allowed in the code
	int		TRIGRAMMS_MAX = 1000;	//maximum of different trigramms allowed in the code

	double	Letter_Freq[] = new double[LETTERS_ENG];
	char	Lookup_Letter[] = new char[LETTERS_ENG];

	double	Bigramm_Freq[] = new double[BIGRAMMS_ENG];
	String	Lookup_Bigramm[] = new String[BIGRAMMS_ENG];

	double	Trigramm_Freq[] = new double[TRIGRAMMS_ENG];
	String	Lookup_Trigramm[] = new String[TRIGRAMMS_ENG];



	double	This_Letter_Freq[] = new double[LETTERS_MAX];
	char	This_Lookup_Letter[] = new char[LETTERS_MAX];

	double	This_Bigramm_Freq[] = new double[BIGRAMMS_MAX];
	String	This_Lookup_Bigramm[] = new String[BIGRAMMS_MAX];

	double	This_Trigramm_Freq[] = new double[TRIGRAMMS_MAX];
	String	This_Lookup_Trigramm[] = new String[TRIGRAMMS_MAX];

	int		CountLetters , CountBigramms , CountTrigramms;


	public String AnalyzeText(String str)
	{
		int		inDictionary;
		int		pos,i,j;
		String	sub;
		String	result = "";
		
		CountLetters = 0;
		CountBigramms = 0;
		CountTrigramms = 0;
		
		if (str.length() >= 1)
		{
			for (pos=0; pos<str.length(); pos++)
			{
				//#################### LETTERS #################################
				//check whether the letter is already in the dictionary
				inDictionary = -1;
				for (i=0; i<CountLetters; i++)
				{
					if (This_Lookup_Letter[i] == str.charAt(pos))
						inDictionary = i;
				}
				//if letter is not in dictionary then create new entry , else increase counter
				if (inDictionary == -1)
				{
					This_Lookup_Letter[CountLetters] = str.charAt(pos);
					This_Letter_Freq[CountLetters] = 1;
					CountLetters++;
				}
				//Letter already in dictionary ?
				else
					This_Letter_Freq[inDictionary] += 1;
				
				//#################### BIGRAMMS #################################
				if (pos<str.length()-1)
				{
					sub = str.substring(pos,pos+2);

					inDictionary = -1;
					for (i=0; i<CountBigramms; i++)
					{
						if (This_Lookup_Bigramm[i].equals(sub))
							inDictionary = i;
					}
					if (inDictionary == -1)
					{
						This_Lookup_Bigramm[CountBigramms] = sub;
						This_Bigramm_Freq[CountBigramms] = 1;
						CountBigramms++;
					}
					else
						This_Bigramm_Freq[inDictionary] += 1;
				}
				
				//#################### TRIGRAMMS #################################
				if (pos<str.length()-2)
				{
					sub = str.substring(pos,pos+3);
					
					inDictionary = -1;
					for (i=0; i<CountTrigramms; i++)
					{
						if (This_Lookup_Trigramm[i].equals(sub))
							inDictionary = i;
					}
					if (inDictionary == -1)
					{
						This_Lookup_Trigramm[CountTrigramms] = sub;
						This_Trigramm_Freq[CountTrigramms] = 1;
						CountTrigramms++;
					}
					else
						This_Trigramm_Freq[inDictionary] += 1;
				}

			}//for (pos=0; pos<str.length(); pos++)

		
			//Get the relative frequency
			for (i=0; i<CountLetters; i++)
				This_Letter_Freq[i] /= str.length();
			for (i=0; i<CountBigramms; i++)
				This_Bigramm_Freq[i] /= (str.length()-1);
			for (i=0; i<CountTrigramms; i++)
				This_Trigramm_Freq[i] /= (str.length()-2);
		
		
			//####################  SORT LETTERS  ##############################
			//now sort the letters from highest-frequent to lowest-frequent
			//(simple BubbleSort)
			double	max;
			double	t1;
			char	t2;
			for (i=0; i<CountLetters-1; i++)
			{
				max = This_Letter_Freq[i];
				for (j=i+1; j<CountLetters; j++)
				{
					//if new maximum is found , swap the letters
					if (This_Letter_Freq[j] > max)
					{
						max = This_Letter_Freq[j];

						t1 = This_Letter_Freq[i];
						This_Letter_Freq[i] = This_Letter_Freq[j];
						This_Letter_Freq[j] = t1;
						
						t2 = This_Lookup_Letter[i];
						This_Lookup_Letter[i] = This_Lookup_Letter[j];
						This_Lookup_Letter[j] = t2;
					}
				}
			}
			
			//####################  SORT BIGRAMMS  ##############################
			String	t3;
			for (i=0; i<CountBigramms-1; i++)
			{
				max = This_Bigramm_Freq[i];
				for (j=i+1; j<CountBigramms; j++)
				{
					//if new maximum is found , swap the letters
					if (This_Bigramm_Freq[j] > max)
					{
						max = This_Bigramm_Freq[j];

						t1 = This_Bigramm_Freq[i];
						This_Bigramm_Freq[i] = This_Bigramm_Freq[j];
						This_Bigramm_Freq[j] = t1;
						
						t3 = This_Lookup_Bigramm[i];
						This_Lookup_Bigramm[i] = This_Lookup_Bigramm[j];
						This_Lookup_Bigramm[j] = t3;
					}
				}
			}

			//####################  SORT TRIGRAMMS  #############################
			for (i=0; i<CountTrigramms-1; i++)
			{
				max = This_Trigramm_Freq[i];
				for (j=i+1; j<CountTrigramms; j++)
				{
					//if new maximum is found , swap the letters
					if (This_Trigramm_Freq[j] > max)
					{
						max = This_Trigramm_Freq[j];

						t1 = This_Trigramm_Freq[i];
						This_Trigramm_Freq[i] = This_Trigramm_Freq[j];
						This_Trigramm_Freq[j] = t1;
						
						t3 = This_Lookup_Trigramm[i];
						This_Lookup_Trigramm[i] = This_Lookup_Trigramm[j];
						This_Lookup_Trigramm[j] = t3;
					}
				}
			}



			//finally put all the information into a string
			result += "Hufigkeiten Monogramme :\n";
			if (CountLetters < LETTERS_ENG)
				j=LETTERS_ENG;
			else
				j=CountLetters;
			for (i=0; i<j; i++)
			{
				NumberFormat f = NumberFormat.getNumberInstance();
				if (i < CountLetters)
				{
					result += This_Lookup_Letter[i]+"\t:"+f.format(This_Letter_Freq[i]*100)+"%";
				}
				if (i < LETTERS_ENG)
					result += "        (Englisch  :\t"+Lookup_Letter[i]+"   :   "+f.format(Letter_Freq[i])+"%)\n";
				else
					result += "\n";
			}
			
			result += "\nHufigkeiten Bigramme :\n";
			if (CountBigramms < BIGRAMMS_ENG)
				j=CountBigramms;
			else
				j=BIGRAMMS_ENG+5;
			for (i=0; i<j; i++)
			{
				NumberFormat f = NumberFormat.getNumberInstance();
				result += This_Lookup_Bigramm[i]+"\t:"+f.format(This_Bigramm_Freq[i]*100)+"%";
				if (i < BIGRAMMS_ENG)
					result += "        (Englisch  :\t"+Lookup_Bigramm[i]+"   :   "+f.format(Bigramm_Freq[i])+"%)\n";
				else
					result +="\n";
			}

			result += "\nHufigkeiten Trigramme :\n";
			if (CountTrigramms < TRIGRAMMS_ENG)
				j=CountTrigramms;
			else
				j=TRIGRAMMS_ENG+5;
			for (i=0; i<j; i++)
			{
				NumberFormat f = NumberFormat.getNumberInstance();
				result += This_Lookup_Trigramm[i]+"\t:"+f.format(This_Trigramm_Freq[i]*100)+"%";
				if (i < TRIGRAMMS_ENG)
					result += "        (Englisch  :\t"+Lookup_Trigramm[i]+"   :   "+f.format(Trigramm_Freq[i])+"%)\n";
				else
					result +="\n";
			}
			result+="\n\n";
		}//if (str.length() >= 1)
		
		return result;
	}//public String AnalyzeText(String str)

	
	public void init()
	{
		Lookup_Letter[0]='e';
		Lookup_Letter[1]='t';
		Lookup_Letter[2]='a';
		Lookup_Letter[3]='o';
		Lookup_Letter[4]='i';
		Lookup_Letter[5]='n';
		Lookup_Letter[6]='s';
		Lookup_Letter[7]='r';
		Lookup_Letter[8]='h';
		Lookup_Letter[9]='l';
		Lookup_Letter[10]='d';
		Lookup_Letter[11]='c';
		Lookup_Letter[12]='u';
		Lookup_Letter[13]='m';
		Lookup_Letter[14]='f';
		Lookup_Letter[15]='p';
		Lookup_Letter[16]='g';
		Lookup_Letter[17]='w';
		Lookup_Letter[18]='y';
		Lookup_Letter[19]='b';
		Lookup_Letter[20]='v';
		Lookup_Letter[21]='k';
		Lookup_Letter[22]='x';
		Lookup_Letter[23]='j';
		Lookup_Letter[24]='q';
		Lookup_Letter[25]='z';


		Letter_Freq[0]=12.51;
		Letter_Freq[1]=9.25;
		Letter_Freq[2]=8.04;
		Letter_Freq[3]=7.60;
		Letter_Freq[4]=7.26;
		Letter_Freq[5]=7.09;
		Letter_Freq[6]=6.54;
		Letter_Freq[7]=6.12;
		Letter_Freq[8]=5.49;
		Letter_Freq[9]=4.14;
		Letter_Freq[10]=3.99;
		Letter_Freq[11]=3.06;
		Letter_Freq[12]=2.71;
		Letter_Freq[13]=2.53;
		Letter_Freq[14]=2.30;
		Letter_Freq[15]=2.00;
		Letter_Freq[16]=1.96;
		Letter_Freq[17]=1.92;
		Letter_Freq[18]=1.73;
		Letter_Freq[19]=1.54;
		Letter_Freq[20]=0.99;
		Letter_Freq[21]=0.67;
		Letter_Freq[22]=0.19;
		Letter_Freq[23]=0.16;
		Letter_Freq[24]=0.11;
		Letter_Freq[25]=0.09;

		Lookup_Bigramm[0]="th";
		Lookup_Bigramm[1]="he";
		Lookup_Bigramm[2]="an";
		Lookup_Bigramm[3]="in";
		Lookup_Bigramm[4]="er";
		Lookup_Bigramm[5]="re";
		Lookup_Bigramm[6]="on";
		Lookup_Bigramm[7]="es";
		Lookup_Bigramm[8]="ti";
		Lookup_Bigramm[9]="at";
		Bigramm_Freq[0]=3.15;
		Bigramm_Freq[1]=2.51;
		Bigramm_Freq[2]=1.72;
		Bigramm_Freq[3]=1.69;
		Bigramm_Freq[4]=1.54;
		Bigramm_Freq[5]=1.48;
		Bigramm_Freq[6]=1.45;
		Bigramm_Freq[7]=1.45;
		Bigramm_Freq[8]=1.28;
		Bigramm_Freq[9]=1.24;
		
		Lookup_Trigramm[0]="the";
		Lookup_Trigramm[1]="ing";
		Lookup_Trigramm[2]="and";
		Lookup_Trigramm[3]="ion";
		Lookup_Trigramm[4]="tio";
		Lookup_Trigramm[5]="ent";
		Lookup_Trigramm[6]="ere";
		Trigramm_Freq[0]=3.53;
		Trigramm_Freq[1]=1.11;
		Trigramm_Freq[2]=1.02;
		Trigramm_Freq[3]=0.75;
		Trigramm_Freq[4]=0.75;
		Trigramm_Freq[5]=0.73;
		Trigramm_Freq[6]=0.69;

		helps[0] = "Die Buchstabenfolge \"the\" ergibt sich am deutlichsten aus den Trigrammen.\nMehr Hilfe ntig?\n";
		helps[1] = "Genau, \"the\" enspricht \";48\"\nAls naechstes sind wieder die Bigramme und Trigramme hilfreich ,\ndenn \"6*\" taucht dort verdammt oft auf.\n";
		helps[2] = "Genau, \"6*\"=\"in\"\nNaechster Tip : \"\"=\"o\"\n";
		helps[3] = "Naechster Tip : \"(\"=\"r\"\n";
		helps[4] = "Naechster Tip : \"5\"=\"a\"\n";
		helps[5] = "Naechster Tip : \")\"=\"s\"\n";
		helps[6] = "Naechster Tip : \"6\"=\"i\"\n";
		helps[7] = "Naechster Tip : \"|\"=\"d\"\n";
		helps[8] = "Naechster Tip : \"?\"=\"u\"\n";
		helps[9] = "Naechster Tip : \"3\"=\"g\"\n";
		helps[10] = "Naechster Tip : \"9\"=\"m\"\n";
		helps[11] = "Naechster Tip : \"1\"=\"f\"\n";
		helps[12] = "Naechster Tip : \":\"=\"y\"\n";
		helps[13] = "Naechster Tip : \"2\"=\"b\"\n";
		helps[14] = "Naechster Tip : \"0\"=\"l\"\n";
		helps[15] = "Naechster Tip : \"#\"=\"v\"\n";
		helps[16] = "Naechster Tip : \".\"=\"p\"\n";
		helps[17] = "Naechster Tip : \"-\"=\"c\"\n";
		helps[18] = "Tja das wars , aber adabee ?? =Stadt?\n";

		setFont(new Font("Courier" , Font.BOLD , 12));
		Button	button = new Button("Replace");
		button.setActionCommand("Replace");
		Button	button2 = new Button("Reset");
		button2.setActionCommand("Reset");
		Button	button3 = new Button("Help");
		button3.setActionCommand("Help");
		
		input.setEditable(false);
		msg.setEditable(false);
		text.setEditable(false);
		
		Panel panel = new Panel();
		panel.setLayout(new GridLayout(4,2));
		panel.add(new Label("Zeichen"));
		panel.add(char1);
		panel.add(new Label("ersetzen durch"));
		panel.add(char2);
		panel.add(button);
		panel.add(button2);
		panel.add(new Label("Messages :"));
		panel.add(button3);

		Panel panel2 = new Panel();
		panel2.setLayout(new GridLayout(4,1));
		panel2.add(new Label("Chiffre :"));
		panel2.add(input);
		panel2.add(panel);
		panel2.add(msg);
		
		setLayout(new GridLayout(1,2));
		add(panel2);
		add(text);
		
		
		input.setText(code);
		String str = AnalyzeText(code);
		text.setText(str);
		
		ActionListener action = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String cmd = e.getActionCommand();
				if (cmd == "Replace")
				{
					String	s1,s2;
					String	message = "";
					
					code = input.getText();
					s1 = char1.getText();
					s2 = char2.getText();
		
					if ((s1.length() != 1) || (s2.length() != 1))
					{
						message += "Kann nur zeichenweise Ersetzungen vornehmen !\n";
						message += "(Da es sich um einen zeichenweisen Substitutionsalgorithmus handelt.)\n";
					}
					if (code.length() < 1)
						message += "Bitte Chiffre eingeben !\n";
					msg.setText(message);
					
					if (message == "")
					{
						//replace the characters
						code = code.replace(s1,s2);
						input.setText(code);

						s2 = "Zeichen "+s1+" ersetzt durch Zeichen "+s2+"\n";
						msg.setText(s2);
						
						//refresh the frequency-table and frequency-textfield
						s1 = AnalyzeText(code);
						text.setText(s1);
					}
				}//if (cmd == "Replace")
				
				if (cmd == "Reset")
				{
					code = code_;
					input.setText(code);
					String s1 = AnalyzeText(code);
					text.setText(s1);
					msg.setText("Reset");
				}
				
				if (cmd == "Help")
				{
					if (index_help < MAXHELPS)
					{
						msg.setText(helps[index_help]);
						index_help++;
					}
				}
			}//public void actionPerformed(ActionEvent e)
		};//ActionListener action = new ActionListener()
		
		button.addActionListener(action);
		button2.addActionListener(action);
		button3.addActionListener(action);

	}
	
	public void start()
	{
		repaint();
	}
	
	public void run()
	{
		repaint();
	}
	
	public void paint(Graphics g)
	{
	}
	
	public void destroy()
	{
	}
};